/* Generated by GOB (v2.0.6) on Mon Dec 15 22:59:15 2003
   (do not edit directly) */

/* End world hunger, donate to the World Food Programme, http://www.wfp.org */

#define GOB_VERSION_MAJOR 2
#define GOB_VERSION_MINOR 0
#define GOB_VERSION_PATCHLEVEL 6

#define selfp (self->_priv)

#include "medusa-treemvc.h"

#include "medusa-treemvc-private.h"

#ifdef G_LIKELY
#define ___GOB_LIKELY(expr) G_LIKELY(expr)
#define ___GOB_UNLIKELY(expr) G_UNLIKELY(expr)
#else /* ! G_LIKELY */
#define ___GOB_LIKELY(expr) (expr)
#define ___GOB_UNLIKELY(expr) (expr)
#endif /* G_LIKELY */


/*  Medusa
 *
 *  medusa-treemvc -- The wigget and model for displaying search results
 *
 *  Copyright (C) 2003 Curtis C. Hovey
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Authors: Curtis C. Hovey <sinzui@cox.net>
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gnome.h>
#include <libgnome/libgnome.h>
#include <libgnomeui/gnome-icon-theme.h>
#include <libgnomeui/gnome-popup-menu.h>

#include <libgnomevfs/gnome-vfs-mime-handlers.h>
#include <libgnomevfs/gnome-vfs-mime-utils.h>
#include <libgnomevfs/gnome-vfs-ops.h>
#include <libgnomevfs/gnome-vfs-utils.h>

#include <bonobo-activation/bonobo-activation.h>

#include <libmedusa-internal/medusa-conf.h>
#include <libmedusa-internal/medusa-search-uri.h>
#include <libmedusa-internal/medusa-master-db.h>
#include <libmedusa/medusa-utils.h>



#define ICON_SIZE 24.0
#define BINARY_EXEC_MIME_TYPE "application/x-executable-binary"
#define ICON_THEME_EXECUTABLE_ICON "gnome-fs-executable"
#define ICON_THEME_REGULAR_ICON "gnome-fs-regular"
#define C_STANDARD_STRFTIME_CHARACTERS "aAbBcdHIjmMpSUwWxXyYZ"
#define C_STANDARD_NUMERIC_STRFTIME_CHARACTERS "dHIjmMSUwWyY"
#define SILENT_WINDOW_OPEN_LIMIT 1;

typedef enum {
	COLUMN_ICON,
	COLUMN_NAME,
	COLUMN_PATH,
	COLUMN_READABLE_SIZE,
	COLUMN_SIZE,
	COLUMN_TYPE,
	COLUMN_READABLE_DATE,
	COLUMN_DATE,
	COLUMN_NO_FILES_FOUND,
	NUM_COLUMNS
} ResultColumn;

static GtkTargetEntry dnd_table[] = {
	{"STRING", 0, 0},
	{"text/plain", 0, 0},
	{"text/uri-list", 0, 1}
};

static const guint n_dnds = sizeof (dnd_table) / sizeof (dnd_table[0]);
		

/* self casting macros */
#define SELF(x) MEDUSA_TREEMVC(x)
#define SELF_CONST(x) MEDUSA_TREEMVC_CONST(x)
#define IS_SELF(x) MEDUSA_IS_TREEMVC(x)
#define TYPE_SELF MEDUSA_TYPE_TREEMVC
#define SELF_CLASS(x) MEDUSA_TREEMVC_CLASS(x)

#define SELF_GET_CLASS(x) MEDUSA_TREEMVC_GET_CLASS(x)

/* self typedefs */
typedef MedusaTreemvc Self;
typedef MedusaTreemvcClass SelfClass;

/* here are local prototypes */
static void medusa_treemvc_init (MedusaTreemvc * o) G_GNUC_UNUSED;
static void medusa_treemvc_class_init (MedusaTreemvcClass * c) G_GNUC_UNUSED;
static void ___1_medusa_treemvc_finalize (GObject * object) G_GNUC_UNUSED;
static void ___real_medusa_treemvc_nonexistent_file (MedusaTreemvc * self, const gchar * uri);
static void ___real_medusa_treemvc_no_app_association (MedusaTreemvc * self, const gchar * uri);
static void ___real_medusa_treemvc_no_file_manager (MedusaTreemvc * self, const gchar * uri);
static void medusa_treemvc_add_file_to_search_results (gpointer uri, gpointer in_treemvc) G_GNUC_UNUSED;
static GdkPixbuf * medusa_treemvc_get_scaled_pixbuf (MedusaTreemvc * treemvc, const gchar * file_path, const gchar * mime_type) G_GNUC_UNUSED;
static gchar * medusa_treemvc_get_file_type_with_mime_type (const gchar * file_path, const gchar * mimetype) G_GNUC_UNUSED;
static gchar * medusa_treemvc_get_file_icon_with_mime_type (const gchar * file_path, const gchar * mime_type) G_GNUC_UNUSED;
static gchar * medusa_treemvc_get_readable_date (const time_t file_time_raw) G_GNUC_UNUSED;
static void medusa_treemvc_drag_begin_file_cb (GtkWidget * widget, GdkDragContext * context, GtkSelectionData * selection, guint info, guint time, gpointer user_data) G_GNUC_UNUSED;
static void medusa_treemvc_drag_file_cb (GtkWidget * widget, GdkDragContext * context, GtkSelectionData * selection, guint info, guint time, gpointer user_data) G_GNUC_UNUSED;
static gboolean medusa_treemvc_file_button_press_event_cb (GtkWidget * widget, GdkEventButton * event, gpointer user_data) G_GNUC_UNUSED;
static gboolean medusa_treemvc_file_key_press_event_cb (GtkWidget * widget, GdkEventKey * event, gpointer user_data) G_GNUC_UNUSED;
static gboolean medusa_treemvc_file_button_release_event_cb (GtkWidget * widget, GdkEventButton * event, gpointer user_data) G_GNUC_UNUSED;
static gboolean medusa_treemvc_file_event_after_cb (GtkWidget * widget, GdkEventButton * event, gpointer user_data) G_GNUC_UNUSED;
static void medusa_treemvc_open_file_cb (GtkWidget * widget, gpointer user_data) G_GNUC_UNUSED;
static void medusa_treemvc_open_folder_cb (GtkWidget * widget, gpointer user_data) G_GNUC_UNUSED;
static gboolean medusa_treemvc_is_nautilus_running (void) G_GNUC_UNUSED;
static gboolean medusa_treemvc_is_component_action_type (const gchar * filename) G_GNUC_UNUSED;
static gboolean medusa_treemvc_open_file_with_nautilus (const gchar * filename) G_GNUC_UNUSED;
static gboolean medusa_treemvc_open_file_with_application (const gchar * filename) G_GNUC_UNUSED;

/*
 * Signal connection wrapper macro shortcuts
 */
#define self_connect__nonexistent_file(object,func,data)	medusa_treemvc_connect__nonexistent_file((object),(func),(data))
#define self_connect_after__nonexistent_file(object,func,data)	medusa_treemvc_connect_after__nonexistent_file((object),(func),(data))
#define self_connect_data__nonexistent_file(object,func,data,destroy_data,flags)	medusa_treemvc_connect_data__nonexistent_file((object),(func),(data),(destroy_data),(flags))
#define self_connect__no_app_association(object,func,data)	medusa_treemvc_connect__no_app_association((object),(func),(data))
#define self_connect_after__no_app_association(object,func,data)	medusa_treemvc_connect_after__no_app_association((object),(func),(data))
#define self_connect_data__no_app_association(object,func,data,destroy_data,flags)	medusa_treemvc_connect_data__no_app_association((object),(func),(data),(destroy_data),(flags))
#define self_connect__no_file_manager(object,func,data)	medusa_treemvc_connect__no_file_manager((object),(func),(data))
#define self_connect_after__no_file_manager(object,func,data)	medusa_treemvc_connect_after__no_file_manager((object),(func),(data))
#define self_connect_data__no_file_manager(object,func,data,destroy_data,flags)	medusa_treemvc_connect_data__no_file_manager((object),(func),(data),(destroy_data),(flags))

typedef void  (*___Sig1) (MedusaTreemvc *, gchar *, gpointer);

static void
___marshal_Sig1 (GClosure *closure,
	GValue *return_value,
	guint n_param_values,
	const GValue *param_values,
	gpointer invocation_hint,
	gpointer marshal_data)
{
	register ___Sig1 callback;
	register GCClosure *cc = (GCClosure*) closure;
	register gpointer data1, data2;

	g_return_if_fail (n_param_values == 2);

	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = g_value_peek_pointer (param_values + 0);
	} else {
		data1 = g_value_peek_pointer (param_values + 0);
		data2 = closure->data;
	}

	callback = (___Sig1) (marshal_data != NULL ? marshal_data : cc->callback);

	callback ((MedusaTreemvc *)data1,
		(gchar *) g_value_get_string (param_values + 1),
		data2);
}


enum {
	NONEXISTENT_FILE_SIGNAL,
	NO_APP_ASSOCIATION_SIGNAL,
	NO_FILE_MANAGER_SIGNAL,
	LAST_SIGNAL
};

static guint object_signals[LAST_SIGNAL] = {0};

/* pointer to the class of our parent */
static GObjectClass *parent_class = NULL;

/* Short form macros */
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#define self_new() medusa_treemvc_new()
#define self_new_with_tree(args...) medusa_treemvc_new_with_tree(args)
#define self_nonexistent_file(args...) medusa_treemvc_nonexistent_file(args)
#define self_no_app_association(args...) medusa_treemvc_no_app_association(args)
#define self_no_file_manager(args...) medusa_treemvc_no_file_manager(args)
#define self_display_results(args...) medusa_treemvc_display_results(args)
#define self_add_file_to_search_results(args...) medusa_treemvc_add_file_to_search_results(args)
#define self_get_scaled_pixbuf(args...) medusa_treemvc_get_scaled_pixbuf(args)
#define self_get_file_type_with_mime_type(args...) medusa_treemvc_get_file_type_with_mime_type(args)
#define self_get_file_icon_with_mime_type(args...) medusa_treemvc_get_file_icon_with_mime_type(args)
#define self_get_readable_date(args...) medusa_treemvc_get_readable_date(args)
#define self_drag_begin_file_cb(args...) medusa_treemvc_drag_begin_file_cb(args)
#define self_drag_file_cb(args...) medusa_treemvc_drag_file_cb(args)
#define self_file_button_press_event_cb(args...) medusa_treemvc_file_button_press_event_cb(args)
#define self_file_key_press_event_cb(args...) medusa_treemvc_file_key_press_event_cb(args)
#define self_file_button_release_event_cb(args...) medusa_treemvc_file_button_release_event_cb(args)
#define self_file_event_after_cb(args...) medusa_treemvc_file_event_after_cb(args)
#define self_open_file_cb(args...) medusa_treemvc_open_file_cb(args)
#define self_open_folder_cb(args...) medusa_treemvc_open_folder_cb(args)
#define self_is_nautilus_running() medusa_treemvc_is_nautilus_running()
#define self_is_component_action_type(args...) medusa_treemvc_is_component_action_type(args)
#define self_open_file_with_nautilus(args...) medusa_treemvc_open_file_with_nautilus(args)
#define self_open_file_with_application(args...) medusa_treemvc_open_file_with_application(args)
#endif /* __GNUC__ && !__STRICT_ANSI__ */

/* Short form pointers */
static MedusaTreemvc * (* const self_new) (void) = medusa_treemvc_new;
static MedusaTreemvc * (* const self_new_with_tree) (GtkWidget * tree) = medusa_treemvc_new_with_tree;
static void (* const self_nonexistent_file) (MedusaTreemvc * self, const gchar * uri) = medusa_treemvc_nonexistent_file;
static void (* const self_no_app_association) (MedusaTreemvc * self, const gchar * uri) = medusa_treemvc_no_app_association;
static void (* const self_no_file_manager) (MedusaTreemvc * self, const gchar * uri) = medusa_treemvc_no_file_manager;
static void (* const self_display_results) (MedusaTreemvc * treemvc, GList * results) = medusa_treemvc_display_results;
static void (* const self_add_file_to_search_results) (gpointer uri, gpointer in_treemvc) = medusa_treemvc_add_file_to_search_results;
static GdkPixbuf * (* const self_get_scaled_pixbuf) (MedusaTreemvc * treemvc, const gchar * file_path, const gchar * mime_type) = medusa_treemvc_get_scaled_pixbuf;
static gchar * (* const self_get_file_type_with_mime_type) (const gchar * file_path, const gchar * mimetype) = medusa_treemvc_get_file_type_with_mime_type;
static gchar * (* const self_get_file_icon_with_mime_type) (const gchar * file_path, const gchar * mime_type) = medusa_treemvc_get_file_icon_with_mime_type;
static gchar * (* const self_get_readable_date) (const time_t file_time_raw) = medusa_treemvc_get_readable_date;
static void (* const self_drag_begin_file_cb) (GtkWidget * widget, GdkDragContext * context, GtkSelectionData * selection, guint info, guint time, gpointer user_data) = medusa_treemvc_drag_begin_file_cb;
static void (* const self_drag_file_cb) (GtkWidget * widget, GdkDragContext * context, GtkSelectionData * selection, guint info, guint time, gpointer user_data) = medusa_treemvc_drag_file_cb;
static gboolean (* const self_file_button_press_event_cb) (GtkWidget * widget, GdkEventButton * event, gpointer user_data) = medusa_treemvc_file_button_press_event_cb;
static gboolean (* const self_file_key_press_event_cb) (GtkWidget * widget, GdkEventKey * event, gpointer user_data) = medusa_treemvc_file_key_press_event_cb;
static gboolean (* const self_file_button_release_event_cb) (GtkWidget * widget, GdkEventButton * event, gpointer user_data) = medusa_treemvc_file_button_release_event_cb;
static gboolean (* const self_file_event_after_cb) (GtkWidget * widget, GdkEventButton * event, gpointer user_data) = medusa_treemvc_file_event_after_cb;
static void (* const self_open_file_cb) (GtkWidget * widget, gpointer user_data) = medusa_treemvc_open_file_cb;
static void (* const self_open_folder_cb) (GtkWidget * widget, gpointer user_data) = medusa_treemvc_open_folder_cb;
static gboolean (* const self_is_nautilus_running) (void) = medusa_treemvc_is_nautilus_running;
static gboolean (* const self_is_component_action_type) (const gchar * filename) = medusa_treemvc_is_component_action_type;
static gboolean (* const self_open_file_with_nautilus) (const gchar * filename) = medusa_treemvc_open_file_with_nautilus;
static gboolean (* const self_open_file_with_application) (const gchar * filename) = medusa_treemvc_open_file_with_application;

GType
medusa_treemvc_get_type (void)
{
	static GType type = 0;

	if ___GOB_UNLIKELY(type == 0) {
		static const GTypeInfo info = {
			sizeof (MedusaTreemvcClass),
			(GBaseInitFunc) NULL,
			(GBaseFinalizeFunc) NULL,
			(GClassInitFunc) medusa_treemvc_class_init,
			(GClassFinalizeFunc) NULL,
			NULL /* class_data */,
			sizeof (MedusaTreemvc),
			0 /* n_preallocs */,
			(GInstanceInitFunc) medusa_treemvc_init,
		};

		type = g_type_register_static (G_TYPE_OBJECT, "MedusaTreemvc", &info, (GTypeFlags)0);
	}

	return type;
}

/* a macro for creating a new object of our type */
#define GET_NEW ((MedusaTreemvc *)g_object_new(medusa_treemvc_get_type(), NULL))

/* a function for creating a new object of our type */
#include <stdarg.h>
static MedusaTreemvc * GET_NEW_VARG (const char *first, ...) G_GNUC_UNUSED;
static MedusaTreemvc *
GET_NEW_VARG (const char *first, ...)
{
	MedusaTreemvc *ret;
	va_list ap;
	va_start (ap, first);
	ret = (MedusaTreemvc *)g_object_new_valist (medusa_treemvc_get_type (), first, ap);
	va_end (ap);
	return ret;
}


static void
___finalize(GObject *obj_self)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::finalize"
	MedusaTreemvc *self = MEDUSA_TREEMVC (obj_self);
	gpointer priv = self->_priv;
	___1_medusa_treemvc_finalize(obj_self);
	g_free (priv);
	return;
	self = NULL;
}
#undef __GOB_FUNCTION__

static void 
medusa_treemvc_init (MedusaTreemvc * o)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::init"
	o->_priv = g_new0 (MedusaTreemvcPrivate, 1);
	o->_priv->tree = NULL;
	o->_priv->store = NULL;
	o->_priv->model = NULL;
	o->_priv->selection = NULL;
	o->_priv->row_selected_by_button_press_event = FALSE;
	o->_priv->pixbufs = NULL;
	return;
	o = NULL;
}
#undef __GOB_FUNCTION__
static void 
medusa_treemvc_class_init (MedusaTreemvcClass * c)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::class_init"
	GObjectClass *g_object_class = (GObjectClass*) c;

	parent_class = g_type_class_ref (G_TYPE_OBJECT);

	object_signals[NONEXISTENT_FILE_SIGNAL] =
		g_signal_new ("nonexistent_file",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
			G_STRUCT_OFFSET (MedusaTreemvcClass, nonexistent_file),
			NULL, NULL,
			___marshal_Sig1,
			G_TYPE_NONE, 1,
			G_TYPE_STRING);
	if ___GOB_UNLIKELY(sizeof(const gchar * ) != sizeof(gchar *)) {
		g_error("medusa-treemvc.gob line 311: Type mismatch of \"nonexistent_file\" signal signature");
	}
	object_signals[NO_APP_ASSOCIATION_SIGNAL] =
		g_signal_new ("no_app_association",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
			G_STRUCT_OFFSET (MedusaTreemvcClass, no_app_association),
			NULL, NULL,
			___marshal_Sig1,
			G_TYPE_NONE, 1,
			G_TYPE_STRING);
	if ___GOB_UNLIKELY(sizeof(const gchar * ) != sizeof(gchar *)) {
		g_error("medusa-treemvc.gob line 330: Type mismatch of \"no_app_association\" signal signature");
	}
	object_signals[NO_FILE_MANAGER_SIGNAL] =
		g_signal_new ("no_file_manager",
			G_TYPE_FROM_CLASS (g_object_class),
			(GSignalFlags)(G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
			G_STRUCT_OFFSET (MedusaTreemvcClass, no_file_manager),
			NULL, NULL,
			___marshal_Sig1,
			G_TYPE_NONE, 1,
			G_TYPE_STRING);
	if ___GOB_UNLIKELY(sizeof(const gchar * ) != sizeof(gchar *)) {
		g_error("medusa-treemvc.gob line 349: Type mismatch of \"no_file_manager\" signal signature");
	}

	g_object_class->finalize = ___finalize;
	c->nonexistent_file = ___real_medusa_treemvc_nonexistent_file;
	c->no_app_association = ___real_medusa_treemvc_no_app_association;
	c->no_file_manager = ___real_medusa_treemvc_no_file_manager;
	return;
	c = NULL;
	g_object_class = NULL;
}
#undef __GOB_FUNCTION__



static void 
___1_medusa_treemvc_finalize (GObject * object)
#define PARENT_HANDLER(___object) \
	{ if(G_OBJECT_CLASS(parent_class)->finalize) \
		(* G_OBJECT_CLASS(parent_class)->finalize)(___object); }
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::finalize"
{
	
		MedusaTreemvc *treemvc;
		
		treemvc = MEDUSA_TREEMVC (object);
		
		if (treemvc->_priv->pixbufs) {
			g_hash_table_destroy (treemvc->_priv->pixbufs);
		}

		if (treemvc->_priv->selection) {
			g_free (treemvc->_priv->selection);
		}

		if (treemvc->_priv->model) {
			g_free (treemvc->_priv->model);
		}

		if (treemvc->_priv->store) {
			g_free (treemvc->_priv->store);
		}

		if (treemvc->_priv->tree) {
			g_object_unref (treemvc->_priv->tree);
		}
	}}
#undef __GOB_FUNCTION__
#undef PARENT_HANDLER

/**
 * medusa_treemvc_new:
 *
 * Makes a new MedusaTreemvc widget to control a tree model
 * and GtkTreeview used to show the Medusa search results.
 *
 * Returns: a new MedusaTreemvc.
 **/
MedusaTreemvc * 
medusa_treemvc_new (void)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::new"
{
	
		GtkWidget *tree;

		tree = gtk_tree_view_new ();

		return (MedusaTreemvc *) self_new_with_tree (tree);
	}}
#undef __GOB_FUNCTION__

/**
 * medusa_treemvc_new_with_tree:
 *
 * @tree: a Gtktreeview widget to be used as the view.
 *
 * Makes a new MedusaTreemvc widget to control a tree model
 * and GtkTreeview used to show the Medusa search results.
 *
 * Returns: a new MedusaTreemvc.
 **/
MedusaTreemvc * 
medusa_treemvc_new_with_tree (GtkWidget * tree)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::new_with_tree"
{
	
		MedusaTreemvc *treemvc;
		GtkTreeViewColumn *column;
		GtkCellRenderer *renderer;

		g_return_val_if_fail (NULL != tree, NULL);
		
		treemvc = GET_NEW;

		treemvc->_priv->tree = tree;
		g_object_ref (G_OBJECT (treemvc->_priv->tree));
		
		treemvc->_priv->store = gtk_list_store_new (NUM_COLUMNS, 
					 		     GDK_TYPE_PIXBUF, 
					 		     G_TYPE_STRING,
					 		     G_TYPE_STRING, 
					 		     G_TYPE_STRING,
					 		     G_TYPE_DOUBLE,
					 		     G_TYPE_STRING,
					 		     G_TYPE_STRING,
					 		     G_TYPE_DOUBLE,
					 		     G_TYPE_BOOLEAN);
		
		gtk_tree_view_set_model (GTK_TREE_VIEW (treemvc->_priv->tree), GTK_TREE_MODEL (treemvc->_priv->store));
		gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treemvc->_priv->tree), FALSE);
		gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (treemvc->_priv->tree), TRUE);
		
		treemvc->_priv->selection = gtk_tree_view_get_selection (GTK_TREE_VIEW (treemvc->_priv->tree));
		
		gtk_tree_selection_set_mode (GTK_TREE_SELECTION (treemvc->_priv->selection), GTK_SELECTION_MULTIPLE);
		
		gtk_drag_source_set (treemvc->_priv->tree, 
				     GDK_BUTTON1_MASK,
				     dnd_table, n_dnds, 
				     GDK_ACTION_COPY | GDK_ACTION_MOVE);
		
		g_signal_connect (G_OBJECT (treemvc->_priv->tree), 
				  "drag_data_get",
				  G_CALLBACK (self_drag_file_cb), 
				  (gpointer) treemvc);
				  
		g_signal_connect (G_OBJECT (treemvc->_priv->tree),
				  "drag_begin",
				  G_CALLBACK (self_drag_begin_file_cb),
				  (gpointer) treemvc);
				  
		g_signal_connect (G_OBJECT (treemvc->_priv->tree), 
				  "event_after",
				  G_CALLBACK (self_file_event_after_cb), 
				  (gpointer) treemvc);
				  
		g_signal_connect (G_OBJECT (treemvc->_priv->tree), 
				  "button_release_event",
				  G_CALLBACK (self_file_button_release_event_cb), 
				  (gpointer) treemvc);
		
		g_signal_connect (G_OBJECT (treemvc->_priv->tree), 
				  "button_press_event",
				  G_CALLBACK (self_file_button_press_event_cb), 
				  (gpointer) treemvc);
	
		g_signal_connect (G_OBJECT (treemvc->_priv->tree),
				  "key_press_event",
				  G_CALLBACK (self_file_key_press_event_cb),
				  (gpointer) treemvc);
		
		/* create the name column */
		column = gtk_tree_view_column_new ();
		gtk_tree_view_column_set_title (column, _("Name"));
		
		renderer = gtk_cell_renderer_pixbuf_new ();
		gtk_tree_view_column_pack_start (column, renderer, FALSE);
		gtk_tree_view_column_set_attributes (column, renderer,
						     "pixbuf", COLUMN_ICON,
						     NULL);
						     
		renderer = gtk_cell_renderer_text_new ();
		gtk_tree_view_column_pack_start (column, renderer, TRUE);
		gtk_tree_view_column_set_attributes (column, renderer,
						     "text", COLUMN_NAME,
						     NULL);				     
		gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
		gtk_tree_view_column_set_resizable (column, TRUE);				     
		gtk_tree_view_column_set_sort_column_id (column, COLUMN_NAME); 
		gtk_tree_view_append_column (GTK_TREE_VIEW (treemvc->_priv->tree), column);
	
		/* create the folder column */
		renderer = gtk_cell_renderer_text_new (); 
		column = gtk_tree_view_column_new_with_attributes (_("Folder"), renderer,
								   "text", COLUMN_PATH,
								   NULL);
		gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
		gtk_tree_view_column_set_resizable (column, TRUE);
		gtk_tree_view_column_set_sort_column_id (column, COLUMN_PATH); 
		gtk_tree_view_append_column (GTK_TREE_VIEW (treemvc->_priv->tree), column);
		
		/* create the size column */
		renderer = gtk_cell_renderer_text_new ();
		g_object_set (renderer, "xalign", 1.0, NULL);
		column = gtk_tree_view_column_new_with_attributes (_("Size"), renderer,
								   "text", COLUMN_READABLE_SIZE,
								   NULL);
		gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
		gtk_tree_view_column_set_resizable (column, TRUE);
		gtk_tree_view_column_set_sort_column_id (column, COLUMN_SIZE);
		gtk_tree_view_append_column (GTK_TREE_VIEW (treemvc->_priv->tree), column);
	 
		/* create the type column */ 
		renderer = gtk_cell_renderer_text_new ();
		column = gtk_tree_view_column_new_with_attributes (_("Type"), renderer,
								   "text", COLUMN_TYPE,
								   NULL);
		gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
		gtk_tree_view_column_set_resizable (column, TRUE);
		gtk_tree_view_column_set_sort_column_id (column, COLUMN_TYPE);
		gtk_tree_view_append_column (GTK_TREE_VIEW (treemvc->_priv->tree), column);
	
		/* create the date modified column */ 
		renderer = gtk_cell_renderer_text_new ();
		column = gtk_tree_view_column_new_with_attributes (_("Date Modified"), renderer,
								   "text", COLUMN_READABLE_DATE,
								   NULL);
		gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
		gtk_tree_view_column_set_resizable (column, TRUE);
		gtk_tree_view_column_set_sort_column_id (column, COLUMN_DATE);
		gtk_tree_view_append_column (GTK_TREE_VIEW (treemvc->_priv->tree), column);
		
		gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (treemvc->_priv->tree), TRUE);

		return treemvc;
	}}
#undef __GOB_FUNCTION__

void 
medusa_treemvc_nonexistent_file (MedusaTreemvc * self, const gchar * uri)
{
	GValue ___param_values[2];
	GValue ___return_val = {0};

	g_return_if_fail (self != NULL);
	g_return_if_fail (MEDUSA_IS_TREEMVC (self));

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_STRING);
	g_value_set_static_string (&___param_values[1], (gchar *) uri);

	g_signal_emitv (___param_values,
		object_signals[NONEXISTENT_FILE_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
}
static void 
___real_medusa_treemvc_nonexistent_file (MedusaTreemvc * self, const gchar * uri)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::nonexistent_file"
{
	
		// The file should not be added to this widget.
	}}
#undef __GOB_FUNCTION__

void 
medusa_treemvc_no_app_association (MedusaTreemvc * self, const gchar * uri)
{
	GValue ___param_values[2];
	GValue ___return_val = {0};

	g_return_if_fail (self != NULL);
	g_return_if_fail (MEDUSA_IS_TREEMVC (self));

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_STRING);
	g_value_set_static_string (&___param_values[1], (gchar *) uri);

	g_signal_emitv (___param_values,
		object_signals[NO_APP_ASSOCIATION_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
}
static void 
___real_medusa_treemvc_no_app_association (MedusaTreemvc * self, const gchar * uri)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::no_app_association"
{
	
		// There is no known app to open this file.
	}}
#undef __GOB_FUNCTION__

void 
medusa_treemvc_no_file_manager (MedusaTreemvc * self, const gchar * uri)
{
	GValue ___param_values[2];
	GValue ___return_val = {0};

	g_return_if_fail (self != NULL);
	g_return_if_fail (MEDUSA_IS_TREEMVC (self));

	___param_values[0].g_type = 0;
	g_value_init (&___param_values[0], G_TYPE_FROM_INSTANCE (self));
	g_value_set_instance (&___param_values[0], (gpointer) self);

	___param_values[1].g_type = 0;
	g_value_init (&___param_values[1], G_TYPE_STRING);
	g_value_set_static_string (&___param_values[1], (gchar *) uri);

	g_signal_emitv (___param_values,
		object_signals[NO_FILE_MANAGER_SIGNAL],
		0 /* detail */,
		&___return_val);

	g_value_unset (&___param_values[0]);
	g_value_unset (&___param_values[1]);
}
static void 
___real_medusa_treemvc_no_file_manager (MedusaTreemvc * self, const gchar * uri)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::no_file_manager"
{
	
		// There is no file manager to view this file/directory.
	}}
#undef __GOB_FUNCTION__

/**
 * medusa_treemvc_display_results:
 *
 * @self: this MedusaTreemvc widget.
 * @results: a GList of uris.
 *
 * Displays the given Medusa search results using 
 * self_add_file_to_search_results().
 *
 * Returns: void.
 **/
void 
medusa_treemvc_display_results (MedusaTreemvc * treemvc, GList * results)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::display_results"
{
	
		g_return_if_fail (NULL != treemvc);
		
		gtk_list_store_clear (GTK_LIST_STORE (treemvc->_priv->store));
		g_list_foreach (results, self_add_file_to_search_results, treemvc);	
	}}
#undef __GOB_FUNCTION__

static void 
medusa_treemvc_add_file_to_search_results (gpointer uri, gpointer in_treemvc)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::add_file_to_search_results"
{
						
		const gchar *file_path;
		gchar *mime_type;
		gchar *description;
		GnomeVFSFileInfo *vfs_file_info;
		GdkPixbuf *pixbuf;
		gchar *readable_size;
		gchar *readable_date;
		gchar *utf8_base_name;
		gchar *utf8_dir_name;
		gchar *base_name;
		gchar *dir_name;
		GtkTreeIter iter;
		MedusaTreemvc *treemvc;
		
		g_return_if_fail (NULL != uri);
		g_return_if_fail (NULL != in_treemvc);
		
		file_path = gnome_vfs_get_local_path_from_uri ((const gchar *) uri);	
		mime_type = gnome_vfs_get_mime_type (file_path);
		description = self_get_file_type_with_mime_type (file_path, mime_type);
		vfs_file_info = gnome_vfs_file_info_new ();
	
		treemvc = MEDUSA_TREEMVC (in_treemvc);
		pixbuf = NULL;
		pixbuf = self_get_scaled_pixbuf (treemvc, file_path, mime_type);
	
		gnome_vfs_get_file_info (file_path, vfs_file_info, GNOME_VFS_FILE_INFO_DEFAULT);
		readable_size = gnome_vfs_format_file_size_for_display (vfs_file_info->size);
		readable_date = self_get_readable_date (vfs_file_info->mtime);
		
		base_name = g_path_get_basename (file_path);
		dir_name = g_path_get_dirname (file_path);
		utf8_base_name = g_locale_to_utf8 (base_name, -1, NULL, NULL, NULL);
		utf8_dir_name = g_locale_to_utf8 (dir_name, -1, NULL, NULL, NULL);
	
		gtk_list_store_append (GTK_LIST_STORE (treemvc->_priv->store), &iter); 
		gtk_list_store_set (GTK_LIST_STORE (treemvc->_priv->store), &iter,
				    COLUMN_ICON, pixbuf, 
				    COLUMN_NAME, utf8_base_name,
				    COLUMN_PATH, utf8_dir_name,
				    COLUMN_READABLE_SIZE, readable_size,
				    COLUMN_SIZE, (-1) * (gdouble) vfs_file_info->size,
				    COLUMN_TYPE, description,
				    COLUMN_READABLE_DATE, readable_date,
				    COLUMN_DATE, (-1) * (gdouble) vfs_file_info->mtime,
				    COLUMN_NO_FILES_FOUND, FALSE,
				    -1);
	
		gnome_vfs_file_info_unref (vfs_file_info);
		g_free (base_name);
		g_free (dir_name);
		g_free (mime_type);
		g_free (utf8_base_name);
		g_free (utf8_dir_name); 
		g_free (readable_size);
		g_free (readable_date);
	}}
#undef __GOB_FUNCTION__

static GdkPixbuf * 
medusa_treemvc_get_scaled_pixbuf (MedusaTreemvc * treemvc, const gchar * file_path, const gchar * mime_type)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::get_scaled_pixbuf"
{
	
		GdkPixbuf *pixbuf;
		const gchar *mime_key;
		
		g_return_val_if_fail (NULL != file_path, NULL);
		g_return_val_if_fail (NULL != treemvc, NULL);
		
		mime_key = NULL;
		if (NULL != mime_type) {
			mime_key = mime_type;
		}
		else {
			mime_key = "unknown";
		}
		
		if (NULL == treemvc->_priv->pixbufs) {
			treemvc->_priv->pixbufs = g_hash_table_new (g_str_hash, g_str_equal);
		}
	
		pixbuf = NULL;
		pixbuf = (GdkPixbuf *) g_hash_table_lookup (treemvc->_priv->pixbufs, mime_key);
		
		if (NULL == pixbuf) {
			gchar *icon_path;
			
			icon_path = NULL;
			icon_path = self_get_file_icon_with_mime_type (file_path, mime_type);
			
			if (NULL != icon_path) {
				pixbuf = gdk_pixbuf_new_from_file (icon_path, NULL);
				g_free (icon_path);
			}
			
			if (NULL != pixbuf) {
				GdkPixbuf *scaled;
				int new_w;
				int new_h;
				int w;
				int h;
				double factor;
				
				w = gdk_pixbuf_get_width (pixbuf);
				h = gdk_pixbuf_get_height (pixbuf);
					
				factor = MIN (ICON_SIZE / w, ICON_SIZE / h);
				new_w  = MAX ((int) (factor * w), 1);
				new_h  = MAX ((int) (factor * h), 1);
					
				scaled = gdk_pixbuf_scale_simple (pixbuf, new_w, new_h, GDK_INTERP_BILINEAR);
												  
				g_object_unref (G_OBJECT (pixbuf));
				pixbuf = scaled;
				
				g_hash_table_insert (treemvc->_priv->pixbufs, g_strdup (mime_key), g_object_ref (pixbuf));
			}
		}
	
		return pixbuf;
	}}
#undef __GOB_FUNCTION__

static gchar * 
medusa_treemvc_get_file_type_with_mime_type (const gchar * file_path, const gchar * mimetype)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::get_file_type_with_mime_type"
{
	
		if (NULL == file_path || NULL == mimetype) {
			return (gchar *) gnome_vfs_mime_get_description (GNOME_VFS_MIME_TYPE_UNKNOWN);
		}
	
		if (g_file_test (file_path, G_FILE_TEST_IS_SYMLINK)) {
			if (g_ascii_strcasecmp (mimetype, GNOME_VFS_MIME_TYPE_UNKNOWN) == 0) {
				GnomeVFSFileInfo *file_info;
			
				file_info = gnome_vfs_file_info_new ();
				gnome_vfs_get_file_info (file_path, file_info, GNOME_VFS_FILE_INFO_DEFAULT);
			
				if (g_file_test (file_info->symlink_name, G_FILE_TEST_EXISTS) != TRUE) {
					gnome_vfs_file_info_unref (file_info);
					return _("link (broken)");
				}
				
				gnome_vfs_file_info_unref (file_info);
			}
			return g_strdup_printf (_("link to %s"), 
						(gchar *) gnome_vfs_mime_get_description (mimetype));
		}
	
		return (gchar *) gnome_vfs_mime_get_description (mimetype);
	}}
#undef __GOB_FUNCTION__

static gchar * 
medusa_treemvc_get_file_icon_with_mime_type (const gchar * file_path, const gchar * mime_type)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::get_file_icon_with_mime_type"
{
	
		const GnomeIconData *icon_data;
		gchar *icon_name;	
		gchar *icon_path;
		int base_size;
		GnomeIconTheme *icon_theme;
		
		icon_name = NULL;
		icon_path = NULL;
		
		icon_theme = gnome_icon_theme_new ();
	
		if (NULL == file_path || NULL == mime_type) {
			icon_name = g_strdup (ICON_THEME_REGULAR_ICON);
		}
		else if ((g_file_test (file_path, G_FILE_TEST_IS_EXECUTABLE)) &&
			 (g_ascii_strcasecmp (mime_type, "application/x-executable-binary") == 0)) {
			icon_name = g_strdup (ICON_THEME_EXECUTABLE_ICON);
		}
		else {
			icon_name = gnome_icon_lookup (icon_theme, NULL, file_path, NULL, 
						       NULL, mime_type, 0, NULL);
		}
	
		icon_path = gnome_icon_theme_lookup_icon (icon_theme, icon_name, ICON_SIZE, 
							  &icon_data, &base_size);
		return icon_path;	
	}}
#undef __GOB_FUNCTION__

static gchar * 
medusa_treemvc_get_readable_date (const time_t file_time_raw)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::get_readable_date"
{
	
		struct tm *file_time;
		gchar *format;
		gchar readable_date[64];
		gsize readable_date_size;
	
		file_time = localtime (&file_time_raw);
		
		format = g_strdup (_("%Y-%m-%d, %-I:%M %p"));
		
		// we need time in GDate to do this safely.
		readable_date_size = strftime (readable_date, 63, format, file_time);		
		g_free (format);
		
		if (0 == readable_date_size) {
			return g_strdup (_("unknown time"));
		}
		return g_strndup (readable_date, readable_date_size);
	}}
#undef __GOB_FUNCTION__

static void 
medusa_treemvc_drag_begin_file_cb (GtkWidget * widget, GdkDragContext * context, GtkSelectionData * selection, guint info, guint time, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::drag_begin_file_cb"
{
	
		g_return_if_fail (NULL != selection);
		g_return_if_fail (NULL != context);
		
		if (gtk_tree_selection_count_selected_rows (GTK_TREE_SELECTION (selection)) > 1) {
			gtk_drag_set_icon_stock (context, GTK_STOCK_DND_MULTIPLE, 0, 0);
		}
		else {
			gtk_drag_set_icon_stock (context, GTK_STOCK_DND, 0, 0);
		}
	}}
#undef __GOB_FUNCTION__

static void 
medusa_treemvc_drag_file_cb (GtkWidget * widget, GdkDragContext * context, GtkSelectionData * selection, guint info, guint time, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::drag_file_cb"
{
		
		MedusaTreemvc *treemvc;
		gchar    	*uri_list = NULL;
		GList 		*list;
		GtkTreeIter 	iter;
		guint 		index;
		
		g_return_if_fail (NULL != selection);
		g_return_if_fail (NULL != user_data);
		
		treemvc = MEDUSA_TREEMVC (user_data);
	
		if (gtk_tree_selection_count_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection)) == 0) {
			return;
		}
		
		list = gtk_tree_selection_get_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection),
							     (GtkTreeModel **) &(treemvc->_priv->model));
		
		for (index = 0; index < g_list_length (list); index++) {
			gboolean   no_files_found = FALSE;
			gchar	   *utf8_name;
			gchar	   *utf8_path;
			gchar	   *file;
			
			gtk_tree_model_get_iter (GTK_TREE_MODEL (treemvc->_priv->model), &iter, 
						 g_list_nth (list, index)->data);
						 
			gtk_tree_model_get (GTK_TREE_MODEL (treemvc->_priv->model), &iter,
	    			    COLUMN_NAME, &utf8_name,
			    	    COLUMN_PATH, &utf8_path,
			    	    COLUMN_NO_FILES_FOUND, &no_files_found,
			   	    -1);	
				    
			file = g_build_filename (utf8_path, utf8_name, NULL);
	
			if (!no_files_found) {
				gchar *tmp_uri = g_filename_to_uri (file, NULL, NULL);
				
				if (uri_list == NULL) {
					uri_list = g_strdup (tmp_uri);
				}
				else{
					uri_list = g_strconcat (uri_list, "\n", tmp_uri, NULL);
				}
				
				gtk_selection_data_set (selection, 
							selection->target,
							8, 
							uri_list, 
							strlen (uri_list));
				g_free (tmp_uri);
			} 
			else {
				gtk_selection_data_set_text (selection, utf8_name, -1);
			}	
			g_free (utf8_name);
			g_free (utf8_path);
			g_free (file);
		}
		g_list_free (list);
		g_free (uri_list);
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_file_button_press_event_cb (GtkWidget * widget, GdkEventButton * event, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::file_button_press_event_cb"
{
	
		MedusaTreemvc *treemvc;
		GtkTreePath *path;
		gboolean row_selected_by_button_press_event = TRUE;
		
		g_return_val_if_fail (NULL != user_data, FALSE);
		
		treemvc = MEDUSA_TREEMVC (user_data);
	
		if (event->window != gtk_tree_view_get_bin_window (GTK_TREE_VIEW (treemvc->_priv->tree))) {
			return FALSE;
		}
		
		if (gtk_tree_view_get_path_at_pos (GTK_TREE_VIEW (treemvc->_priv->tree), event->x, event->y,
		    &path, NULL, NULL, NULL)) {
			
			if ((event->button == 1 || event->button == 3)
				&& gtk_tree_selection_path_is_selected (gtk_tree_view_get_selection (GTK_TREE_VIEW (treemvc->_priv->tree)), path)) {
				
				row_selected_by_button_press_event = FALSE;
			}
			
			gtk_tree_path_free (path);
		}
		else {
			gtk_tree_selection_unselect_all (gtk_tree_view_get_selection (GTK_TREE_VIEW (treemvc->_priv->tree)));
		}
		
		return !(row_selected_by_button_press_event);
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_file_key_press_event_cb (GtkWidget * widget, GdkEventKey * event, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::file_key_press_event_cb"
{
			
		g_return_val_if_fail (NULL != widget, FALSE);
		g_return_val_if_fail (NULL != user_data, FALSE);
		
		if (event->keyval == GDK_space || event->keyval == GDK_Return) {
			self_open_file_cb (widget, user_data);
			return TRUE;
		}
		
		return FALSE;
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_file_button_release_event_cb (GtkWidget * widget, GdkEventButton * event, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::file_button_release_event_cb"
{
	
		MedusaTreemvc *treemvc;
		gboolean no_files_found = FALSE;
		GtkTreeIter iter;
		
		g_return_val_if_fail (NULL != user_data, FALSE);
		
		treemvc = MEDUSA_TREEMVC (user_data);
		
	
		if (event->window != gtk_tree_view_get_bin_window (GTK_TREE_VIEW (treemvc->_priv->tree))) {
			return FALSE;
		}
		
		if (gtk_tree_selection_count_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection)) == 0) {
			return FALSE;
		}
			
		if (event->button == 1) {
			GtkTreePath *path;
	
			if (gtk_tree_view_get_path_at_pos (GTK_TREE_VIEW (treemvc->_priv->tree), event->x, event->y,
			    &path, NULL, NULL, NULL)) {
				if ((event->state & GDK_SHIFT_MASK) || (event->state & GDK_CONTROL_MASK)) {
					if (treemvc->_priv->row_selected_by_button_press_event) {
						gtk_tree_selection_select_path (gtk_tree_view_get_selection (GTK_TREE_VIEW (treemvc->_priv->tree)), path);
					}
					else {
						gtk_tree_selection_unselect_path (gtk_tree_view_get_selection (GTK_TREE_VIEW (treemvc->_priv->tree)), path);
					}
				}
				else {
					gtk_tree_selection_unselect_all (gtk_tree_view_get_selection (GTK_TREE_VIEW (treemvc->_priv->tree)));
					gtk_tree_selection_select_path (gtk_tree_view_get_selection (GTK_TREE_VIEW (treemvc->_priv->tree)), path);
				}
			}
	
			gtk_tree_path_free (path);
		}	
		if (event->button == 3) {	
			GtkWidget *popup;
			GList *list;
			
			list = gtk_tree_selection_get_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection),
								     (GtkTreeModel **) &(treemvc->_priv->model));
			
			gtk_tree_model_get_iter (GTK_TREE_MODEL (treemvc->_priv->model), &iter, 
						 g_list_first (list)->data);
						 
			gtk_tree_model_get (GTK_TREE_MODEL(treemvc->_priv->model), &iter,
				    	    COLUMN_NO_FILES_FOUND, &no_files_found,
				   	    -1);		    
			     
			if (!no_files_found) {
				GnomeUIInfo popup_menu[] = {
					GNOMEUIINFO_ITEM_STOCK (N_("_Open"), 
						NULL, 
						self_open_file_cb,
						GTK_STOCK_OPEN),
					GNOMEUIINFO_ITEM_STOCK (N_("O_pen Folder"), 
						NULL, 
						self_open_folder_cb,
						GTK_STOCK_OPEN),
					GNOMEUIINFO_END
				};
					
				popup = gnome_popup_menu_new (popup_menu);
				
				gnome_popup_menu_do_popup (GTK_WIDGET (popup), NULL, NULL, 
							   (GdkEventButton *) event, user_data, NULL);			   
			}
	
			g_list_free (list);
		}	
		return FALSE;
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_file_event_after_cb (GtkWidget * widget, GdkEventButton * event, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::file_event_after_cb"
{
		
		MedusaTreemvc *treemvc;
		GtkTreeIter iter;
		
		g_return_val_if_fail (NULL != user_data, FALSE);
		
		treemvc = MEDUSA_TREEMVC (user_data);
	
		if (event->window != gtk_tree_view_get_bin_window (GTK_TREE_VIEW (treemvc->_priv->tree))) {
			return FALSE;
		}
		
		if (gtk_tree_selection_count_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection)) == 0) {
			return FALSE;
		}
			
		if (event->type == GDK_2BUTTON_PRESS) {
	
			gboolean no_files_found = FALSE;
			gchar *utf8_name;
			gchar *utf8_path;	 
			GList *list;
			
			list = gtk_tree_selection_get_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection),
								     (GtkTreeModel **) &(treemvc->_priv->model));
			
			gtk_tree_model_get_iter (GTK_TREE_MODEL (treemvc->_priv->model), &iter, 
						 g_list_first (list)->data);
						 
			gtk_tree_model_get (GTK_TREE_MODEL (treemvc->_priv->model), &iter,
	    				    COLUMN_NAME, &utf8_name,
				    	    COLUMN_PATH, &utf8_path,
				    	    COLUMN_NO_FILES_FOUND, &no_files_found,
				   	    -1);	
			
			if (!no_files_found) {
				gchar *file;
				gchar *locale_file;
				
				file = g_build_filename (utf8_path, utf8_name, NULL);
				locale_file = g_locale_from_utf8 (file, -1, NULL, NULL, NULL);
				
				if (self_is_component_action_type (locale_file) && self_is_nautilus_running ()) {
					self_open_file_with_nautilus (locale_file);
				}
				else {
					self_open_file_with_application (locale_file);
					g_warning ("NO_APP_ASSOCIATION_SIGNAL");
					// g_signal_emit (treemvc, NO_APP_ASSOCIATION_SIGNAL, 0, locale_file);	
				}

				g_free (file);
				g_free (locale_file);
			} 

			g_free (utf8_name);
			g_free (utf8_path);
			g_list_free (list);
		}

		return FALSE;
	}}
#undef __GOB_FUNCTION__

static void 
medusa_treemvc_open_file_cb (GtkWidget * widget, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::open_file_cb"
{
	
		MedusaTreemvc *treemvc;
		GList *list;
		guint index;
		
		g_return_if_fail (NULL != user_data);
		
		treemvc = MEDUSA_TREEMVC (user_data);
	
		if (gtk_tree_selection_count_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection)) == 0) {
			return;
		}
		
		list = gtk_tree_selection_get_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection),
							     (GtkTreeModel **) &(treemvc->_priv->model));
	
		
		for (index = 0; index < g_list_length(list); index++) {
		
			gboolean no_files_found = FALSE;
			gchar *utf8_name;
			gchar *utf8_path;
			GtkTreeIter iter;
				
			gtk_tree_model_get_iter (GTK_TREE_MODEL (treemvc->_priv->model), &iter, 
						 g_list_nth (list, index)->data);
	
			gtk_tree_model_get (GTK_TREE_MODEL(treemvc->_priv->model), &iter,
	    				    COLUMN_NAME, &utf8_name,
				    	    COLUMN_PATH, &utf8_path,
				    	    COLUMN_NO_FILES_FOUND, &no_files_found,
				   	    -1);		    
	
			if (!no_files_found) {
				gchar *file;
				gchar *locale_file;
					
				file = g_build_filename (utf8_path, utf8_name, NULL);
				locale_file = g_locale_from_utf8 (file, -1, NULL, NULL, NULL);
				
				if (self_is_component_action_type (locale_file) && self_is_nautilus_running ()) {
					self_open_file_with_nautilus (locale_file);
				}
				else {
					self_open_file_with_application (locale_file);
					// g_warning ("NO_APP_ASSOCIATION_SIGNAL");
					// g_signal_emit (treemvc, NO_APP_ASSOCIATION_SIGNAL, 0, locale_file);
				} 
				g_free (file);
				g_free (locale_file);
			}
			g_free (utf8_name);
			g_free (utf8_path);
		} 
		g_list_free (list);
	}}
#undef __GOB_FUNCTION__

static void 
medusa_treemvc_open_folder_cb (GtkWidget * widget, gpointer user_data)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::open_folder_cb"
{
	
		MedusaTreemvc *treemvc;
		GList *list;
		guint index;
		
		g_return_if_fail (NULL != user_data);
		
		treemvc = MEDUSA_TREEMVC (user_data);
		
		if (gtk_tree_selection_count_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection)) == 0) {
			return;
		}
		
		list = gtk_tree_selection_get_selected_rows (GTK_TREE_SELECTION (treemvc->_priv->selection),
							     (GtkTreeModel **) &(treemvc->_priv->model));	
	
		for (index = 0; index < g_list_length(list); index++) {
			gchar *folder_locale;
			gchar *folder_utf8;
			GtkTreeIter iter;
			
			gtk_tree_model_get_iter (GTK_TREE_MODEL (treemvc->_priv->model), &iter, 
						 g_list_nth (list, index)->data);
						 
			gtk_tree_model_get (GTK_TREE_MODEL (treemvc->_priv->model), &iter,
					    COLUMN_PATH, &folder_utf8,
					    -1);
				    							
			folder_locale = g_filename_from_utf8 (folder_utf8, -1, NULL, NULL, NULL);
			
			if (self_is_nautilus_running ()) {
				self_open_file_with_nautilus (folder_locale);
			}
			else {
				g_warning ("NO_FILE_MANAGER_SIGNAL");
				// g_signal_emit (treemvc, NO_FILE_MANAGER_SIGNAL, 0, folder_locale);
			}
			g_free (folder_locale);
			g_free (folder_utf8);
		}

		g_list_free (list);
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_is_nautilus_running (void)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::is_nautilus_running"
{
	
		CORBA_Environment ev;
		CORBA_Object obj;
		gboolean ret;
		
		CORBA_exception_init (&ev); 
		obj = bonobo_activation_activate_from_id ("OAFIID:Nautilus_Factory",
							  Bonobo_ACTIVATION_FLAG_EXISTING_ONLY, 
							  NULL, 
							  &ev);
			
		ret = !CORBA_Object_is_nil (obj, &ev);
		
		CORBA_Object_release (obj, &ev);	
		CORBA_exception_free (&ev);
		
		return ret;
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_is_component_action_type (const gchar * filename)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::is_component_action_type"
{
	
		gchar *mimeType;
		GnomeVFSMimeActionType actionType;
		
		g_return_val_if_fail (NULL != filename, FALSE);
		
		mimeType = gnome_vfs_get_mime_type (filename);
		actionType = gnome_vfs_mime_get_default_action_type (mimeType);
		
		g_free (mimeType);
		
		if (actionType == GNOME_VFS_MIME_ACTION_TYPE_COMPONENT) {
			return TRUE;
		}
		
		return FALSE;
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_open_file_with_nautilus (const gchar * filename)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::open_file_with_nautilus"
{
	
		int argc = 5;
		char **argv;
		
		g_return_val_if_fail (NULL != filename, FALSE);
		
		argv = g_new0 (char *, argc);
		
		argv[0] = "nautilus";
		argv[1] = "--sm-disable";
		argv[2] = "--no-desktop";
		argv[3] = "--no-default-window";
		argv[4] = (gchar *) filename;
		
		gnome_execute_async (NULL, argc, argv);
		g_free (argv);
		
		return TRUE;
	}}
#undef __GOB_FUNCTION__

static gboolean 
medusa_treemvc_open_file_with_application (const gchar * filename)
{
#define __GOB_FUNCTION__ "Medusa:Treemvc::open_file_with_application"
{
	
		gchar *mimeType;
		GnomeVFSMimeApplication *mimeApp;
		
		g_return_val_if_fail (NULL != filename, FALSE);
		
		mimeType = gnome_vfs_get_mime_type (filename);
		mimeApp = gnome_vfs_mime_get_default_application (mimeType);
		
		g_free (mimeType);
			
		if (mimeApp) {
			gint  argc;
			gchar **argv;
			gchar *command_line;
			
			command_line = g_strdup_printf ("%s '%s'", mimeApp->command, 
						        g_strescape (filename, "\r\n"));
			
			g_shell_parse_argv (command_line, &argc, &argv, NULL); 
				
			if (mimeApp->requires_terminal) {
				gnome_prepend_terminal_to_vector (&argc, &argv);	
			}
			
			gnome_execute_async (NULL, argc, argv);	
			gnome_vfs_mime_application_free (mimeApp);
			g_free (command_line);	
			g_free (argv);
			
			return TRUE;
		}
		
		return FALSE;
	}}
#undef __GOB_FUNCTION__


#if (!defined __GNUC__) || (defined __GNUC__ && defined __STRICT_ANSI__)
/*REALLY BAD HACK
  This is to avoid unused warnings if you don't call
  some method.  I need to find a better way to do
  this, not needed in GCC since we use some gcc
  extentions to make saner, faster code */
static void
___medusa_treemvc_really_bad_hack_to_avoid_warnings(void)
{
	((void (*)(void))GET_NEW_VARG)();
	((void (*)(void))self_new)();
	((void (*)(void))self_new_with_tree)();
	((void (*)(void))self_nonexistent_file)();
	((void (*)(void))self_no_app_association)();
	((void (*)(void))self_no_file_manager)();
	((void (*)(void))self_display_results)();
	((void (*)(void))self_add_file_to_search_results)();
	((void (*)(void))self_get_scaled_pixbuf)();
	((void (*)(void))self_get_file_type_with_mime_type)();
	((void (*)(void))self_get_file_icon_with_mime_type)();
	((void (*)(void))self_get_readable_date)();
	((void (*)(void))self_drag_begin_file_cb)();
	((void (*)(void))self_drag_file_cb)();
	((void (*)(void))self_file_button_press_event_cb)();
	((void (*)(void))self_file_key_press_event_cb)();
	((void (*)(void))self_file_button_release_event_cb)();
	((void (*)(void))self_file_event_after_cb)();
	((void (*)(void))self_open_file_cb)();
	((void (*)(void))self_open_folder_cb)();
	((void (*)(void))self_is_nautilus_running)();
	((void (*)(void))self_is_component_action_type)();
	((void (*)(void))self_open_file_with_nautilus)();
	((void (*)(void))self_open_file_with_application)();
	___medusa_treemvc_really_bad_hack_to_avoid_warnings();
}
#endif /* !__GNUC__ || (__GNUC__ && __STRICT_ANSI__) */

